<?php
// Bloc Carrousel
// SAEZAM Core v4.0
// Date : 28-05-2013
$nomclass="bloc_carrousel";

if(!class_exists("bloc_carrousel")){
class bloc_carrousel extends module {
	var $nom="Bloc Carrousel";
	var $scripts=array("js/greensock/uncompressed/plugins/CSSPlugin.js","js/greensock/uncompressed/easing/EasePack.js","js/greensock/uncompressed/TimelineLite.js","js/greensock/uncompressed/TweenLite.js");
	var $groupeid=12;
	var $defaultvalues=array(
				   "titre" 				=> "" ,
				   "categorieid" 		=> 0,
				   "sliderDuration" 	=> 8,
				   "transitionDuration"	=> 1,
				   "dimimageliste"		=> 4,
				   "dimimagezoom"		=> 4,
				   "plus"				=>	"En savoir plus",
				   "typebloc"			=>	"zoomtotal"
				   );
	var $form_1=array(
					  array(
						"titre"			=> "Titre" ,
						"variable"		=> "titre",
						"typeinput"		=> "text",
						"ismultilingue"	=> true
					  ),
					  array(
									"titre"			=> "Que voulez-vous faire défiler ?" ,
									"variable"		=> "typeslider",
									"typeinput"		=> "select",
									"options"		=> array(
															 array(
																   "titre" 	=> "Des articles",
																   "value" 	=> "articles"
															),
															 array(
																   "titre" 	=> "Des images",
																   "value" 	=> "dossier"
															),
														)
					),
					  array(
						"titre"			=> "Categorie" ,
						"variable"		=> "categorie",
						"typeinput"		=> "listeselect",
						"classe"		=> "categorie"
					  ),
					  array(
						"titre"			=> "Dossier" ,
						"variable"		=> "dossier",
						"typeinput"		=> "listeselect",
						"classe"		=> "dossier"
					  ),
					  array(
						"titre"			=> "Durée d'une diapo (s)" ,
						"variable"		=> "sliderDuration",
						"typeinput"		=> "text"
					  ),
					  array(
						"titre"			=> "Durée d'une transition (s)" ,
						"variable"		=> "transitionDuration",
						"typeinput"		=> "text"
					  )
					);
	var $form_plus=array(
						 array(
									"titre"			=> "Type de Slides" ,
									"variable"		=> "typebloc",
									"typeinput"		=> "select",
									"options"		=> array(
															 array(
																   "titre" 	=> "Normales",
																   "value" 	=> ""
															),
															 array(
																   "titre" 	=> "Images en grand",
																   "value" 	=> "zoomtotal"
															),
														)
					)
						 
						 );
	function HTML($instance){
		global $siteInfo;
		global $currentUser;
		if(!isset($instance->galerieid) or $instance->galerieid==""){$instance->galerieid=1;}
		if(!isset($instance->lien) or $instance->lien==""){$instance->lien=0;}
		if(!isset($instance->sliderDuration) or $instance->sliderDuration=="" or $instance->sliderDuration==0){$instance->sliderDuration=7;}
		?>
        <div id="conteneur_<?php echo $instance->id;?>">
		</div>
		<a href="" class="nogo prev_carroussel" id="prev_<?php echo $instance->id;?>" onclick="prev<?php echo $instance->id;?>();"></a>
		<a href="" class="nogo next_carroussel" id="next_<?php echo $instance->id;?>" onclick="next<?php echo $instance->id;?>();"></a>
		<div id="sommaire_<?php echo $instance->id;?>" class="sommaire_carroussel">
		</div>     
        <?php 
		$id=$instance->id;
		if($instance->typeslider=="categorie"){
			$cat=new categorie;
			$cat->serial=$instance->categorie;
			$cat->getInfo();
			
			$gabarit=new gabarit;
			$gabarit->id=$cat->gabaritid;
			$gabarit->getInfo();
			
			$liste=new liste;
			$liste->type=$gabarit->classecible;
			$liste->getList("WHERE categorieid='$cat->id' AND active=1 ORDER BY date_crea",true);
		}else if($instance->typeslider=="dossier"){ 
			$dossier=new dossier;
			$dossier->serial=$instance->dossier;
			$dossier->getInfo();
			
			$liste=new liste;
			$liste->type="image";
			$liste->getList("WHERE type='image' AND dossierid='$dossier->id' AND active=1 ORDER BY ordre ASC",true);
		}
		if(!empty($liste->liste)){?>
			<script>
			$("#conteneur_<?php echo $instance->id;?>").css({position:"relative"});
			$("#conteneur_<?php echo $instance->id;?>").css("height",$("#<?php echo $instance->module->nom;?>_<?php echo $instance->id;?>").height()+"px");
			var id=<?php echo $id;?>;
			var slides_<?php echo $id;?>=new Array;
			var current="";
			var action="start";
			<?php 
			$i=0;
			if($instance->typeslider=="categorie"){
			foreach($liste->liste as $article){
				$image=new image;
				if($article->imageid!=0){
					$image->id=$article->imageid;
				}else{
					continue;
				}
				$image->getInfo();
				$lien=$article->url;
				$titre=$article->nom;
				$html=$article->html;
				$plus=$instance->plus;
				?>
				slides_<?php echo $id;?>.push(new Array("<?php 
				if($lien!==false){
					 echo "<a href='$lien'>";
				}
				$image->afficher($instance->dimimageliste,"carrousel zoomtotal");
				if($lien!==false){
					echo "</a>";
				}
				?>",<?php echo $image->largeur;?>,<?php echo $image->hauteur;?>,"<?php 
				if($lien!=""){
					 echo "<a href='$lien'>";
				}
				echo rawurlencode(language($article,"nom"));
				if($lien!==false){
					echo "</a>";
				}?>","<?php echo rawurlencode(language($article,"html"));?>"));
				$("#sommaire_<?php echo $id;?>").append("<div class='puce_carroussel' id='puce<?php echo $i."_".$id;?>'></div>");
				$("#puce<?php echo $i."_".$id;?>").mouseover(function(){
																if(current><?php echo $i;?>){
																	action="right";
																	nextdiapo(<?php echo $i;?>);
																}else if(current<<?php echo $i;?>){
																	action="left";
																	nextdiapo(<?php echo $i;?>);  
																}
																clearInterval(timer_<?php echo $id;?>);
																timer_<?php echo $id;?>=window.setInterval(next, duration_<?php echo $id;?>);
														});
				
				<?php $i++;}
				
			}else if($instance->typeslider=="dossier"){
			foreach($liste->liste as $image){
				?>
				slides_<?php echo $id;?>.push(new Array("<?php 
				rawurlencode($image->afficher($instance->dimimageliste,$instance->dimimagezoom,"carrousel-image"));
				?>",<?php echo $image->largeur;?>,<?php echo $image->hauteur;?>,"",""));				
				<?php $i++;}
				
			}?>
				
				nextdiapo(0);
				
				function nextdiapo(next){
					creerdiapo(next);
					$("#slide"+next+"_<?php echo $id;?>").css({"z-index":0});
					$("#slide"+current+"_<?php echo $id;?>").css({"z-index":1});
					$("#slide"+next+"_<?php echo $id;?> .caroussel-img img").load(
															   function(){
																   //resizeslider_<?php echo $instance->id;?>(next);
																   actionate(next);
																   }
															   );
					
					}
					
				function actionate(next){
					$("div.puce_carroussel").removeClass("current_puce");
					$("#puce"+next+"_<?php echo $id;?>").addClass("current_puce");
					if(action=="start"){
						gostart(next);
						}
					if(action=="left"){
						goleft(next);
						}
					if(action=="right"){
						goright(next);
						}
					}
					
				function gostart(next){
					$("#slide"+next+"_<?php echo $id;?>").animate({
															  opacity:1
															  },200);
					current=next;
					}
					
				function goleft(next){
					
					//$("#slide"+next+"_<?php echo $id;?>").animate({
															  //left:"0px",
															  //opacity:1
															 // },200);
					TweenLite.to($("#slide"+current+"_<?php echo $id;?>"), 0.3, {css:{
									  "left":"-"+$("#slide"+current+"_<?php echo $id;?>").width()+"px"},
										 ease:Strong.easeInOut,
										 overwrite:"all",
										 onComplete:endAnim,
										 onCompleteParams:["#slide"+current+"_<?php echo $id;?>",next]});
									
					}
				
				function goright(next){
					//$("#slide"+next+"_<?php echo $id;?>").animate({
															 // left:"0px",
															 // opacity:1
															 // },200);
					TweenLite.to($("#slide"+current+"_<?php echo $id;?>"), 0.3, {css:{
									  "left":"+"+$("#slide"+current+"_<?php echo $id;?>").width()+"px"},
										 ease:Strong.easeInOut,
										 overwrite:"all",
										 onComplete:endAnim,
										 onCompleteParams:["#slide"+current+"_<?php echo $id;?>",next]});
					}
					
				function endAnim(id,next){
					$(id).remove();
					current=next;
					}
				
				function next<?php echo $id;?>(){
					if(slides_<?php echo $id;?>[current+1]==null){
						nextdiapoid=0;
					}else{
						nextdiapoid=current+1;
						}
					if(current!=nextdiapoid){
						action="left";
						nextdiapo(nextdiapoid);
						tl.stop();
						tl = new TimelineLite({delay:<?php echo $instance->sliderDuration;?>});
						tl.call(next<?php echo $id;?>);
					}
					}
					
				function prev<?php echo $id;?>(){
					if(slides_<?php echo $id;?>[current-1]==null){
						nextdiapoid=slides_<?php echo $id;?>.length-1;
					}else{
						nextdiapoid=current-1;
						}
					if(current!=nextdiapoid){
						action="right";
						nextdiapo(nextdiapoid);
						tl.stop();
						tl = new TimelineLite({delay:<?php echo $instance->sliderDuration;?>});
						tl.call(next<?php echo $id;?>);
					}
					}
				
				function creerdiapo(next){
					if(action=="start"){
					$("#conteneur_<?php echo $id;?>").append('<div id="slide'+next+'_<?php echo $id;?>" style="width:100%;height:100%;overflow:hidden;opacity:0;position:absolute;top:0;left:0;"><h2 class="caroussel-nom" id="nom'+next+'_<?php echo $id;?>">'+decodeURIComponent(slides_<?php echo $id;?>[next][3])+'</h2><div class="caroussel-img" id="img'+next+'_<?php echo $id;?>">'+slides_<?php echo $id;?>[next][0]+'</div><div class="caroussel-html" id="html'+next+'_<?php echo $id;?>">'+decodeURIComponent(slides_<?php echo $id;?>[next][4])+'</div></div>');
					}else{
					$("#conteneur_<?php echo $id;?>").append('<div id="slide'+next+'_<?php echo $id;?>" style="width:100%;height:100%;overflow:hidden;position:absolute;top:0;left:0;"><h2 class="caroussel-nom" id="nom'+next+'_<?php echo $id;?>">'+decodeURIComponent(slides_<?php echo $id;?>[next][3])+'</h2><div class="caroussel-img" id="img'+next+'_<?php echo $id;?>">'+slides_<?php echo $id;?>[next][0]+'</div><div class="caroussel-html" id="html'+next+'_<?php echo $id;?>">'+decodeURIComponent(slides_<?php echo $id;?>[next][4])+'</div></div>');
						}
					initialiserliens('#slide'+next+'_<?php echo $id;?>');
					}
				
				var tl = new TimelineLite({delay:<?php echo $instance->sliderDuration;?>});
				tl.call(next<?php echo $id;?>);
				$("body").bind("PageChangeBegin",function(event,url){
										 tl.stop();
										 tl.remove(); 
										  })
				$(window).resize(function() {
						//resizeslider_<?php echo $instance->id;?>(current);
						  })
		function resizeslider_<?php echo $id;?>(slideid){
	$("#conteneur_<?php echo $instance->id;?>").css("width",$("#masque_<?php echo $instance->id;?>").css("width"));
			$("#conteneur_<?php echo $instance->id;?>").css("height",$("#<?php echo $instance->module->nom;?>_<?php echo $instance->id;?>").height()+"px");
			 var ratio=slides_<?php echo $id;?>[slideid][1]/slides_<?php echo $id;?>[slideid][2];
			 var ratioscreen=$("#<?php echo $instance->module->nom;?>_<?php echo $id;?>").width()/$("#<?php echo $instance->module->nom;?>_<?php echo $id;?>").height();
						  if(ratioscreen<ratio){
							$("#slide"+slideid+"_<?php echo $id;?> img").css("height",$("#<?php echo $instance->module->nom;?>_<?php echo $id;?>").height()+"px");
							$("#slide"+slideid+"_<?php echo $id;?> img").css("width",$("#<?php echo $instance->module->nom;?>_<?php echo $id;?>").height()*ratio+"px");
							$("#slide"+slideid+"_<?php echo $id;?> img").css({
								position:"relative",
								left:"-"+(($("#slide"+slideid+"_<?php echo $id;?> img").width()-$("#<?php echo $instance->module->nom;?>_<?php echo $id;?>").width())/2)+"px",
								top:0
								})
						}else{
							$("#slide"+slideid+"_<?php echo $id;?> img").css("width",$("#<?php echo $instance->module->nom;?>_<?php echo $id;?>").width()+"px");
							$("#slide"+slideid+"_<?php echo $id;?> img").css("height",$("#<?php echo $instance->module->nom;?>_<?php echo $id;?>").width()/ratio+"px");
							$("#slide"+slideid+"_<?php echo $id;?> img").css({
								position:"relative",
								top:"-"+(($("#slide"+slideid+"_<?php echo $id;?> img").height()-$("#<?php echo $instance->module->nom;?>_<?php echo $id;?>").height())/2)+"px",
								left:0
							})
						  }
			}
			function survolerPuce(){
				
				}
			<?php if($instance->typebloc!=""){?>
					$("#<?php echo $instance->module->nom;?>_<?php echo $instance->id;?>").addClass("<?php echo $instance->typebloc;?>");
			<?php }?>
			</script>
			
			
		<?php }?>
<?php }

	
function edit($instance){
			global $siteInfo;?>
			<li>
				<?php listedossier("Categorie","categorieid","publication",$instance->categorieid);?>
    		</li>
            <li><label for="sliderDuration">Durée d'une diapo : </label><input type="text" value="<?php echo $instance->sliderDuration;?>" id="sliderDuration" name="sliderDuration" /></li>
			<li><label for="dimimageliste">Dimension Image : </label>
<select id="dimimageliste" name="dimimageliste">
<option <?php if($instance->dimimageliste==0){?> selected="selected" <?php }?> value='0'>Taille d'origine</option>
<?php 
$listedimensions=new listedimension;
		$listedimensions->getDimensionList();
		 foreach($listedimensions->listedimension as $dim){?>
<option <?php if($instance->dimimageliste==$dim->dimensionid){?> selected="selected" <?php }?> value='<?php echo $dim->dimensionid;?>'><?php echo $dim->dossier;?></option>
<?php }?>
</select>

</li>
    <li><label for="lien">Lien : </label>
<select id="lien" name="lien">
<option <?php if($instance->lien==0){?> selected="selected" <?php }?> value='0'>non</option>
<option <?php if($instance->lien==1){?> selected="selected" <?php }?> value='1'>oui vers le billet</option>
<option <?php if($instance->lien==2){?> selected="selected" <?php }?> value='2'>oui vers le lien du billet s'il existe</option>
</select>

</li>
	<?php }
	
function options($instance){
	global $siteInfo;?>

	<?php }
}

}?>
